#include <iostream>
#include <algorithm>
#include <cstdio>
#define mp make_pair

using namespace std;

inline void build(int *h, int *l, int *r, int n) {
	for (int i = 0; i < n; i++) {
		int j = i - 1;
		while (j != -1 && h[j] >= h[i]) {
			j = l[j];
		}
		l[i] = j;
	}
	for (int i = n - 1; i >= 0; i--) {
		int j = i + 1;
		while (j != n && h[j] >= h[i]) {
			j = r[j];
		}
		r[i] = j;
	}
}

const int N = 111111;
int n, a[N], b[N];
int la[N], ra[N], lb[N], rb[N];

pair<int, pair<int, bool> > s[2 * N];

int main() {
	#ifndef SHTRIX
	freopen("shopping.dat", "rt", stdin);
	freopen("shopping.sol", "wt", stdout);	
	#endif
	scanf("%d", &n);
	for (int i = 0; i < n; i++) scanf("%d", &a[i]);
	for (int i = 0; i < n; i++) scanf("%d", &b[i]);
	build(a, la, ra, n);
	build(b, lb, rb, n);
	for (int i = 0; i < n; i++) s[i] = mp(a[i], mp(ra[i] - la[i] - 1, 0));
	for (int i = 0; i < n; i++) s[i + n] = make_pair(b[i], mp(rb[i] - lb[i] - 1, 1));
	sort(s, s + 2 * n);
	reverse(s, s + 2 * n);
	long long res = 0;
	int mxlen0 = 0, mxlen1 = 0;
	for (int i = 0; i < 2 * n; i++) {
		int h = s[i].first;
		int len = s[i].second.first;
		int id = s[i].second.second;
		if (id == 0) {
			res = max(res, h * 1LL * len * mxlen1);
			mxlen0 = max(mxlen0, len);
		} else {
			res = max(res, h * 1LL * len * mxlen0);			
			mxlen1 = max(mxlen1, len);
		}
	}
	cout << res << endl;
	return 0;
}