#define maxV 500

void graph(int subproblem, int neighborsCount, int neighbors[], int &current, int &whereToGo, int &answer)
{
    if (subproblem == 1)
    {
        bool zeroNeighbor = false;
        int whereFrom = maxV + 1, subtreeCount = 0;
        for (int i = 0; i < neighborsCount; i++)
            if (neighbors[i] == 0)
                zeroNeighbor = true;
            else if (neighbors[i] < current)
                subtreeCount += neighbors[i];
            else if (neighbors[i] < whereFrom)
                whereFrom = neighbors[i];
        if (zeroNeighbor)
        {
            current = whereFrom - 1;
            whereToGo = 0;
        } else
        {
            current = subtreeCount + 1;
            if (whereFrom <= maxV)
                whereToGo = whereFrom;
            else
                answer = current;
        }
    } else
    {
        int whereFrom = 1, zeroNeighbor = -1;
        for (int i = 0; i < neighborsCount; i++)
            if (neighbors[i] <= 1)
                zeroNeighbor = (neighbors[i] > zeroNeighbor ? neighbors[i] : zeroNeighbor);
            else if ((current <= 1 || neighbors[i] < current) && neighbors[i] > whereFrom)
                whereFrom = neighbors[i];
        if (current == 1)
            answer = whereFrom - 1;
        else
        {
            current = whereFrom + 1;
            whereToGo = (zeroNeighbor >= 0 ? zeroNeighbor : whereFrom);
        }
    }
}
